#define PIN_CTRL    A4    /* 電圧設定ボリュームピン */
#define PIN_VE      A0    /* エミッタ電圧測定ピン */
#define PIN_LED_VF  A2    /* LED Vf測定ピン */
#define PIN_VOUT    6     /* 電圧出力ピン */

#define VREF        5.0   /* リファレンス電圧 */
#define RLED        100.0 /* LED電流制限抵抗値 */

float v_lsb = VREF / 1024.0;  // ADC 1ビットあたりの電圧

void setup() {
  Serial.begin(9600);
}

void loop() {
  int   adc_ctrl;     // ADC値: 電圧設定ボリューム
  int   adc_ve;       // ADC値: エミッタ電圧（＝抵抗を含めた印加電圧）
  int   adc_led_vf;   // ADC値: LEDのVf
  float led_if;
  char  str_buf[32];  

  adc_ctrl = analogRead(PIN_CTRL) >> 2;
  analogWrite(PIN_VOUT, adc_ctrl);

  adc_ve = analogRead(PIN_VE);
  adc_led_vf = analogRead(PIN_LED_VF);

  Serial.print("PWM: ");
  Serial.print(adc_ctrl);

  Serial.print("  Ve: ");
  // Serial.print(adc_ve);
  // Serial.print(" ");
  Serial.print(v_lsb * (float)adc_ve);

  Serial.print("  Vf: ");
  // Serial.print(adc_led_vf);
  // Serial.print(" ");
  Serial.print(v_lsb * (float)adc_led_vf);

  led_if = (v_lsb * (float)(adc_ve - adc_led_vf)) / RLED;
  dtostrf((led_if * 1000.0), 6, 3, str_buf);   // *1000でmA
  Serial.print("  If: ");
  Serial.print(str_buf);
 
  dtostrf(((v_lsb * (float)(1024 - adc_led_vf)) / led_if), 7, 3, str_buf);
  Serial.print("  R: ");
  Serial.println(str_buf);

  delay(1000);
}
